--
-- Created by IntelliJ IDEA.
-- User: Ilya
-- Date: 16.07.12
-- Time: 15:06
-- To change this template use File | Settings | File Templates.
--

local getmetatable, setmetatable, tostring = getmetatable, setmetatable, tostring

local address = function(self)
    local mt = getmetatable(self)
    local t = mt.__tostring
    mt.__tostring = nil
    local s = tostring(self)
    mt.__tostring = t
    return s:sub(8)
end


local class = function(base)
    local cls = {}
    cls.__index = cls

    local mt = {
        __index = base,

        __call = function (c, ...)
            local instance = setmetatable({}, cls)
            if cls.init then
                cls.init(instance, ...)
            end

            cls.address = address

            return instance
        end
    }

    return setmetatable(cls, mt)
end

return class